#!/bin/python3

# requires PIL for image edition
# upemtk is used and given with the sources (requires tkinter)

# To use the program:
# Put a point on the first image
# Then on a the second
# When you are happy of your work, launch the generation by pressing 'm'
# Look at the result in the 'media' directory

# can be launch with the following options 
# - frames : to generate (default 16)
# - start : starting image (should be .png)
# - end : ending image
# example : python3 main.py frames=10 start=media/gorilla.png end=media/panda.png

# an example of generation is given in the 'example' directory

# Actions :

# Mouse :
# LeftClick : add a point (you have to add first one on the left image and then an other on the right image)

# Keys :
# m - to start the morphing (frames will be generate in 'media')

from interface import *
from parse_args import *
import sys

img_start = "media/panda.png"
img_end = "media/gorilla.png"

if __name__ == "__main__":
	interface = Interface(img_start, img_end)
	parser = ParseArgs()
	
	# command options
	
	parser.add("frames", lambda val :
		interface.set_frames(int(val)))
	parser.add("start", lambda val :
		interface.set_image("start", val))
	parser.add("end", lambda val :
		interface.set_image("end", val))
	
	parser.parse(sys.argv)
	
	# events and actions in the program
	
	interface.add_mouse_event('ClicGauche', lambda ev, interface :
		interface.add_coord(clic_x(ev), clic_y(ev)))
	
	interface.add_key_event('q', lambda ev, interface :
		interface.quit())
	interface.add_key_event('m', lambda ev, interface :
		interface.build_morpho())
		
	# process
	
	while interface.active():
		interface.draw()
		interface.event()
	
	exit()