from functools import reduce

prod = lambda l : reduce(lambda x, y : x * y, l)

det2 = lambda a, b : a[0] * b[1] - a[1] * b[0]

sub = lambda a, b : [ea - eb for ea, eb in zip(a, b)]

add = lambda a, b : [ea + eb for ea, eb in zip(a, b)]

mul = lambda scalar, l : [scalar * e for e in l]

scalar_prod = lambda a, b : sum([ea * eb for ea, eb in zip(a, b)])

def in_triangle(p, t):
	for i in range(3):
		if det2(sub(t[i], t[(i + 2) % 3]), sub(p, t[(i + 2) % 3])) * \
		det2(sub(p, t[(i + 2) % 3]), sub(t[(i + 1) % 3], t[(i + 2) % 3])) <= 0:
			return False
	return True

def barycentric_coordinates(P, T):
	A, B, C = tuple(T)
	PA, PB, PC = tuple([tuple(sub(e, P)) for e in T])
	AB, AC = (tuple(sub(B, A)), tuple(sub(C, A)))
	alpha, beta, gamma = (det2(PB, PC), det2(PC, PA), det2(PA, PB))
	tt = det2(AB, AC)
	return tuple([e / tt for e in (alpha, beta, gamma)])

def cartesian_coordinates(B, T):
	return tuple(map(int, reduce(add, [mul(s, p) for s, p in zip(B, T)])))